/* $VER: WBStars_functions.c 2.0 (18 Dec 1996)
*/

#include <proto/graphics.h>
#include <proto/layers.h>

#include "WBStars_include.h"
#include "WBStars_protos.h"
#include "WBStars_plot.h"

void	SetPixel(int x, int y)
{
	ULONG	APen;		/* because this is not "our" RastPort	*/
	ULONG	BPen;		/* we have to save the things that we	*/
	ULONG	DrMd;		/* will change to write the Pixel		*/

	if(!locked) LockLayerInfo(LInfo);

	APen	= GetAPen(RPort);	/* get the Pens and	*/
	BPen	= GetBPen(RPort);	/* the DrawMode		*/
	DrMd	= GetDrMd(RPort);

	SetABPenDrMd(RPort, fg_color, BPen, JAM1);	/* set our Pens and DrawMode*/
	WritePixel(RPort,x+minx,y+miny);			/* Write our Pixel			*/

	SetABPenDrMd(RPort, APen, BPen, DrMd);		/* Reset the Rastport		*/

	if(!locked) UnlockLayerInfo(LInfo);
}

void	ClearPixel(int x, int y)
{
	ULONG	APen;
	ULONG	BPen;
	ULONG	DrMd;

	if(!locked) LockLayerInfo(LInfo);

	APen	= GetAPen(RPort);
	BPen	= GetBPen(RPort);
	DrMd	= GetDrMd(RPort);

	SetABPenDrMd(RPort, bg_color, BPen, JAM1);
	WritePixel(RPort,x+minx,y+miny);

	SetABPenDrMd(RPort, APen, BPen, DrMd);

	if(!locked) UnlockLayerInfo(LInfo);
}

char	SetPixelTest(int x, int y)
{
	ULONG	APen;
	ULONG	BPen;
	ULONG	DrMd;

	if(!locked) LockLayerInfo(LInfo);

	if( ReadPixel(RPort,x+minx,y+miny)==bg_color )
	{
		APen	= GetAPen(RPort);
		BPen	= GetBPen(RPort);
		DrMd	= GetDrMd(RPort);

		SetABPenDrMd(RPort, fg_color, BPen, JAM1);
		WritePixel(RPort,x+minx,y+miny);

		SetABPenDrMd(RPort, APen, BPen, DrMd);

		if(!locked) UnlockLayerInfo(LInfo);

		return TRUE;
	}

	if(!locked) UnlockLayerInfo(LInfo);

	return FALSE;
}

char	ClearPixelTest(int x, int y)
{
	ULONG	APen;
	ULONG	BPen;
	ULONG	DrMd;

	if(!locked) LockLayerInfo(LInfo);

	if( ReadPixel(RPort,x+minx,y+miny)==fg_color )
	{
		APen	= GetAPen(RPort);
		BPen	= GetBPen(RPort);
		DrMd	= GetDrMd(RPort);

		SetABPenDrMd(RPort, bg_color, BPen, JAM1);
		WritePixel(RPort,x+minx,y+miny);

		SetABPenDrMd(RPort, APen, BPen, DrMd);

		if(!locked) UnlockLayerInfo(LInfo);

		return TRUE;
	}

	if(!locked) UnlockLayerInfo(LInfo);

	return FALSE;
}

char	Test1Pixel(int x, int y)
{
	if( ReadPixel(RPort,x+minx,y+miny)==fg_color )
	{
		return TRUE;
	}

	return FALSE;
}

char	Test0Pixel(int x, int y)
{
	if( ReadPixel(RPort,x+minx,y+miny)==bg_color )
	{
		return TRUE;
	}

	return FALSE;
}

void	LockPlotArea()
{
	if(!locked)
	{
		LockLayerInfo(LInfo);
		locked=TRUE;
	}
}

void	UnlockPlotArea()
{
	if(locked)
	{
		UnlockLayerInfo(LInfo);
		locked=FALSE;
	}
}
